#line 1 "C:/PIC/MikroC/PIC16/PIC16F887/ServoFromADCx2intosc/forum.c"
#line 25 "C:/PIC/MikroC/PIC16/PIC16F887/ServoFromADCx2intosc/forum.c"
volatile unsigned char PWM1_level_next;
volatile unsigned char PWM2_level_next;
volatile unsigned int PWM1_high_time = 0;
volatile unsigned int PWM2_high_time = 0;
volatile unsigned char PWM1_low_count = 0;

void Interrupt(){
 unsigned int TMR1_value;

 if (TMR0IF_bit){
 TMR0IF_bit = 0;
 if(PWM1_level_next){
 PORTD.B0 = 1;
 PWM1_low_count = 0;
 PWM1_level_next = 0;
 TMR0 = 226 - (PWM1_high_time >> 1);
 }
 else{
 PORTD.B0 = 0;
 PWM1_low_count++;
 if(PWM1_low_count < 6){
 TMR0 = 43;
 }
 else{
 TMR0 = 114 + (PWM1_high_time >> 1);
 PWM1_level_next = 1;
 PWM1_low_count = 0;
 }
 }
 }

 if (TMR1IF_bit){
 TMR1IF_bit = 0;
 if(PWM2_level_next){
 PORTD.B1 = 1;
 PWM2_level_next = 0;
 TMR1_value = 65479 - (PWM2_high_time);
 TMR1H = TMR1_value >> 8;
 TMR1L = TMR1_value & 0xff;
 }
 else{
 PORTD.B1 = 0;
 TMR1_value = 63100 + (PWM2_high_time);
 TMR1H = TMR1_value >> 8;
 TMR1L = TMR1_value & 0xff;
 PWM2_level_next = 1;
 }
 }
}

void main(){

 TRISC = 0;
 TRISD = 0;
 PORTC = 0;
 PORTD = 0;

 OPTION_REG = 0x83;

 T1CON = 0x31;
 TMR1IF_bit = 0;
 TMR1H = 0xff;
 TMR1L = 0xE0;
 TMR1IE_bit = 1;
 INTCON = 0xE0;

 while(1){
 PWM1_high_time = ADC_Read(0)/4;
 PWM2_high_time = ADC_Read(1)/4;
 }
}
